<template>
  <b-card-code
    title="Lista de actividades"
    no-body

  >
      <div class="m-2">
        <b-row>

           <!-- Search -->
          <b-col
            cols="12"
            md="6"
            class="d-flex align-items-center justify-content-start mb-1 mb-md-0"
          >
             <b-form-input
                v-model="searchQuery"
                class="d-inline-block mr-1"
                placeholder="Search..."
              />
          </b-col>
          <!-- Add client button -->
          <b-col
            cols="12"
            md="6"
          >
            <div class="d-flex align-items-center justify-content-end">
             
              <b-button 
                v-if="boolCreate"
                variant="primary" 
                :to="{ name: 'apps-project-activities-create',params: { id:  this.$route.params.id} }"
              >
                <span class="text-nowrap">+ Nuevo</span>
              </b-button>
            </div>
          </b-col>
        </b-row>
      </div>
    <b-table
      :fields="fields"
      :items="activities"
      responsive
      :filter="searchQuery"
      class="mb-0"
      show-empty
      sticky-header
      empty-text="No se encontraron registros"
    >

      <!-- A virtual column -->
      <template #cell(index)="data">
        {{ data.item.id  }}
      </template>

      <template #cell(user_manager)="data">

          <b-avatar
            v-if="data.item.user_manager.image"
            class="mr-1" 
            size="lg"
            :src="baseURL+data.item.user_manager.image"
          />
          <b-avatar
            v-else
            class="mr-1" 
            size="lg"
           
          />
          {{ data.item.user_manager.name }} {{data.item.user_manager.last_name}}
     
      </template>

      <!-- A custom formatted column -->
      <template #cell(progress)="data">
        <b-progress
          :value="data.item.percentage_advance"
          max="100"
          height="7px"
          :variant="percentageVariant(data.item.percentage_advance)"
          striped
        />
        {{data.item.percentage_advance}}%
      </template>

      <template #cell(status)="data">
        <b-badge
          pill
          :variant="statusVariant(data.value.id)"
        >
          {{ data.value.name }}
        </b-badge>
      </template>

      <!-- A virtual composite column -->
       <!-- Column: Actions -->
        <template #cell(actions)="data">
          <b-dropdown
            variant="link"
            no-caret
          >

            <template #button-content>
              <feather-icon
                icon="MoreVerticalIcon"
                size="16"
                class="align-middle text-body"
              />
            </template>
            <b-dropdown-item v-if="userId === data.item.manager_id || (data.item.project && (userId === data.item.project.manager_id)) || hasPermission('show_project_activities')" :to="{ name: 'apps-project-activities-view', params: { activitie: data.item.id } }">
              <feather-icon icon="FileTextIcon" />
              <span class="align-middle ml-50">Detalles</span>
            </b-dropdown-item>

            <b-dropdown-item v-if="userId === data.item.manager_id || (data.item.project && (userId === data.item.project.manager_id)) || hasPermission('edit_project_activities')" :to="{ name: 'apps-project-activities-edit', params: { activitie: data.item.id } }">
              <feather-icon icon="EditIcon" />
              <span class="align-middle ml-50">Editar</span>
            </b-dropdown-item>

            <b-dropdown-item v-if=" data.item.project && (userId === data.item.project.manager_id || hasPermission('delete_project_activities'))" >
              <feather-icon icon="TrashIcon" />
              <span @click="deleteActivitie(data.item.id)" class="align-middle ml-50">Eliminar</span>
            </b-dropdown-item>
          </b-dropdown>
        </template>


    </b-table>
 
  </b-card-code>
</template>

<script>
import BCardCode from '@core/components/b-card-code/BCardCode.vue'
import { BTable, BProgress, BBadge,BDropdown, BDropdownItem, BAvatar, BButton,BRow, BCol, BFormInput,} from 'bootstrap-vue'

export default {
  components: {
    BCardCode,
    BTable,
    BProgress,
    BBadge,
    BDropdown, 
    BDropdownItem,
    BAvatar,
    BButton,
    BRow, 
    BCol, 
    BFormInput
  },
  name:'activities-table',
  data() {
    return {
      fields: [
        // A virtual column that doesn't exist in items
        'index',
        // A column that needs custom formatting
        { key: 'name', label: 'Nombre' },
        { key: 'user_manager', label: 'Encargado' },
        // A regular column
        { key: 'progress', label: 'Progreso' },
        // A regular column
        { key: 'status', label: 'Estado' },
        // A virtual column made up from two fields
        { key: 'Actions', label: 'Actions' },
      ],
      activities: [],
      searchQuery:'',
      baseURL:'http://quantumdaily-back.test/storage/',
      boolCreate:false,
      projectManager:'',
      userId:''

    }
  },
  methods:{
    getActivities(){
      this.$http.get('project/activities',{params:{project:this.$route.params.id}}).then(res=>{
        this.activities = res.data.activities
        // console.log(this.activities[0])
      }).catch(err=>{
        console.log(err)
      })
    },
    
   deleteActivitie(activitie){
      this.$swal({
        title: '¿Está seguro de eliminar el registro?',
        text: "No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, eliminar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          this.$http.get('project/activities/delete',{params:{activitie:activitie}}).then(res=>{
            this.$swal({
                icon: 'success',
                title: 'Eliminado!',
                text: 'El registro ha sido eliminado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
            this.getActivities()
          }).catch(err=>{
            console.log(err)
          })
      } else {
          this.$swal({
            title: 'Cancelado',
            text: 'El registro esta a salvo :)',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
    })
    },
    statusVariant(status){
      if(status === 1){
        return 'secondary'
      }else if(status === 2){
        return 'info'
      }else if(status === 3){
        return 'success'
      }else if(status === 4){
        return 'warning'
      }else if(status === 5){
        return 'primary'
      }
    },
    percentageVariant(percentage){
      if(percentage <= 30){
        return 'primary'
      }else if(percentage > 30 && percentage <= 70){
        return 'warning'
      }else if(percentage > 70 && percentage < 100){
        return 'info'
      }else if(percentage === 100){
        return 'success'
      }
    },
    getProjectManager(){
      this.$http.get('project/show',{params:{id:this.$route.params.id}}).then(res=>{
        this.projectManager = res.data.project.manager_id
        this.checkCreatePermission()
      }).catch(err=>{
        console.log(err)
      })
    },
    checkCreatePermission(){
      let userData = JSON.parse(localStorage.userData)
      this.userId = userData.id
        if ( this.hasPermission('add_project_activities') || userData.id === this.projectManager) {
          this.boolCreate = true
          return true
        }else {
          return false
        }
      }
  },
  mounted(){
    this.getActivities()
    this.getProjectManager()

  
  }
}
</script>
